//+------------------------------------------------------------------+
//|                                                  rainbow wma.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  PaleVioletRed
#property indicator_width1  2

//
//
//
//
//

extern int  RwmaLength = 5;
extern int  Price      = PRICE_CLOSE;

//
//
//
//
//

double  ma[];
double  pBuffer[][10];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,ma);
         RwmaLength = MathMax(RwmaLength,2);
   IndicatorShortName("rainbow wma ("+RwmaLength+")");
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,l,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;
           if (ArrayRange(pBuffer,0) != Bars) ArrayResize(pBuffer,Bars);

   //
   //
   //
   //
   //
   
   double weight = (RwmaLength+1)*RwmaLength*0.5;
   for(i=limit, r=Bars-limit-1; i>=0; i--,r++)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      
      //
      //
      //
      //
      //

      double coeff  = 5;
      double sum    = 0;
      double sumc   = 0;
      for (int k=0; k<10; k++)
      {
         pBuffer[r][k] = price;
         if (r>RwmaLength)
         {
            for (l=0, price=0; l<RwmaLength; l++) price += (RwmaLength-l)*pBuffer[r-l][k];
                                                  price /= weight;
         }
         sum  += coeff*price;
         sumc += coeff;
         coeff = MathMax(coeff-1,1);
      }
      ma[i] = sum/sumc;
   }
   return(0);
}